//
//  NEXSituation.h
//  NumberEightCompiled
//
//  Created by Oliver Kocsis on 19/06/2018.
//  Copyright © 2018 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NEDevicePosition.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * Represents a device's position relative to the user, and its orientation.
 *
 * The state represents the position relative to the user.
 * The orientation represents the device's physical orientation.
 */
@interface NEXDevicePosition : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param devicePosition NEDevicePosition to copy from.
 */
- (instancetype)initWithDevicePosition:(NEDevicePosition)devicePosition;

/**
 * Conversion copy constructor.
 * @param devicePosition NEDevicePosition to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithDevicePosition:(NEDevicePosition)devicePosition
                            confidence:(double)confidence;

/**
 * @param state State to assume.
 */
- (instancetype)initWithState:(NEDevicePositionState)state;

/**
 * @param state State to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithState:(NEDevicePositionState)state confidence:(double)confidence;

/**
 * @param orientation Orientation to assume.
 */
- (instancetype)initWithOrientation:(NEDevicePositionOrientation)orientation;

/**
 * @param orientation Orientation to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithOrientation:(NEDevicePositionOrientation)orientation
                         confidence:(double)confidence;

/**
 * @param state State to assume.
 * @param orientation Orientation to assume.
 */
- (instancetype)initWithState:(NEDevicePositionState)state
                  orientation:(NEDevicePositionOrientation)orientation;

/**
 * @param state State to assume.
 * @param orientation Orientation to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithState:(NEDevicePositionState)state
                  orientation:(NEDevicePositionOrientation)orientation
                   confidence:(double)confidence;

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 *
 * @return `nil` if unserialization failed.
 */
+ (instancetype _Nullable)unserializeWithString:(NSString*)string;

@property(nonatomic, readonly) NEDevicePosition value DEPRECATED_ATTRIBUTE;

/**
 * The device's position relative to the user.
 */
@property(nonatomic, readwrite) NEDevicePositionState state;

/**
 * The device's physical orientation.
 */
@property(nonatomic, readwrite) NEDevicePositionOrientation orientation;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

+ (NSString*)stringFromState:(NEDevicePositionState)state;
+ (NSString*)stringFromOrientation:(NEDevicePositionOrientation)orientation;

/**
 * Strict equality comparison.
 *
 * @see NEDevicePosition_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NEDevicePosition)c_val;

@end
NS_ASSUME_NONNULL_END
